Loading...
Searching...
No Matches
trans_tpfa.h File Reference

Routines to assist in the calculation of two-point transmissibilities. More...

`#include <opm/grid/UnstructuredGrid.h>`

Go to the source code of this file.

## Functions

void | tpfa_htrans_compute (struct UnstructuredGrid *G, const double *perm, double *htrans)
| Calculate static, one-sided transmissibilities for use in the two-point flux approximation method.
void | tpfa_trans_compute (struct UnstructuredGrid *G, const double *htrans, double *trans)
| Compute two-point transmissibilities from one-sided transmissibilities.
void | tpfa_eff_trans_compute (struct UnstructuredGrid *G, const double *totmob, const double *htrans, double *trans)
| Calculate effective two-point transmissibilities from one-sided, total mobility weighted, transmissibilities.

## Detailed Description

Routines to assist in the calculation of two-point transmissibilities.

## Function Documentation

## tpfa_eff_trans_compute()

void tpfa_eff_trans_compute | ( | struct UnstructuredGrid * | G,
|  | const double * | totmob,
|  | const double * | htrans,
|  | double * | trans )

Calculate effective two-point transmissibilities from one-sided, total mobility weighted, transmissibilities.

Specifically, compute the following product

in which and are the one-sided, static transmissibility values connecting the cells of face `f` and and denote the total mobilities of the respective cells.

Parameters

  [in] | G | Grid.
  [in] | totmob | Total mobilities. One positive scalar value for each cell.
  [in] | htrans | One-sided transmissibilities as defined by function tpfa_htrans_compute().
  [out] | trans | Effective, two-point transmissibilities. Array of size at least `G->number_of_faces`.

## tpfa_htrans_compute()

void tpfa_htrans_compute | ( | struct UnstructuredGrid * | G,
|  | const double * | perm,
|  | double * | htrans )

Calculate static, one-sided transmissibilities for use in the two-point flux approximation method.

The one-sided transmissibilities are defined by the formula

in which `i` is the half-face index corresponding to the cell-face index pair `(c,f)` and is the centroid difference vector.

Parameters

  [in] | G | Grid.
  [in] | perm | Permeability. One symmetric, positive definite tensor per grid cell.
  [out] | htrans | One-sided transmissibilities. Array of size at least `G->cell_facepos[ G->number_of_cells ]`.

## tpfa_trans_compute()

void tpfa_trans_compute | ( | struct UnstructuredGrid * | G,
|  | const double * | htrans,
|  | double * | trans )

Compute two-point transmissibilities from one-sided transmissibilities.

The two-point transmissibilities are given by the simple, near-harmonic average (save a factor of two)

in which and are the one-sided transmissibilities that connect the neighbouring cells of face `f`.

Parameters

  [in] | G | Grid.
  [in] | htrans | One-sided transmissibilities as defined by function tpfa_htrans_compute().
  [out] | trans | Interface, two-point transmissibilities. Array of size at least `G->number_of_faces`.